#
# procfs example
#

TARGET = procfs_rw
CURDIR = $(shell pwd)
TEST_READ = echo 123456789 > /proc/example/buffer
TEST_WRITE = cat /proc/example/buffer
BUILD_KERNEL = "/lib/modules/$(shell uname -r)/build"
EXTRA_CFLAGS += "-DNOTQUEM"
# BUILD_KERNEL = "/home/yura/basecamp/Linux_Kernel_GL_Basecamp/linux-5.6.12/linux_build"
# EXTRA_CFLAGS += "-DQUEM"

ifneq ($(KERNELRELEASE),)

obj-m := $(TARGET).o
$(TARGET)-objs := src/rw.o

else

KERNELDIR := $(BUILD_KERNEL)

.PHONY: all clean
all:
	$(MAKE) -C $(KERNELDIR) M=$(CURDIR) modules
clean:
	$(MAKE) -C $(KERNELDIR) M=$(CURDIR) clean

endif

test: all
	sudo dmesg -C
	sudo insmod $(TARGET).ko
	echo "123456789" > /proc/example/buffer
	cat /proc/example/buffer
	sudo rmmod $(TARGET).ko
	dmesg
test_quem:
	scp -P 8022 *.ko user@localhost:/home/user
	ssh -p 8022 user@localhost "sudo -S insmod $(TARGET).ko; $(TEST_READ); $(TEST_WRITE); sudo rmmod $(TARGET).ko; dmesg | tail -20"
